unit Image32_Ex;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Graphics32, Spin;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    rgBitmapAlign: TRadioGroup;
    Image: TImage32;
    rgScaleMode: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    sbScale: TScrollBar;
    CheckBox1: TCheckBox;
    rgSpriteOrigin: TRadioGroup;
    Timer1: TTimer;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    procedure rgBitmapAlignClick(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure sbScaleChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure rgSpriteOriginClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
  public
    Time: Integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  sbScale.Enabled := False;
end;

procedure TForm1.rgBitmapAlignClick(Sender: TObject);
const
  BA_CONSTS: array [0..1] of TBitmapAlign = (baTopLeft, baCenter);
begin
  Image.BitmapAlign := BA_CONSTS[rgBitmapAlign.ItemIndex];
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
const
  SM_CONSTS: array [0..3] of TScaleMode = (smNormal, smStretch, smScale, smResize);
begin
  if Sender is TRadioButton then
  begin
    Image.ScaleMode := SM_CONSTS[TRadioButton(Sender).Tag];
    sbScale.Enabled := RadioButton3.Checked;
  end;
end;

procedure TForm1.sbScaleChange(Sender: TObject);
begin
  Image.Scale := sbScale.Position / 100;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Image.DoubleBuffered := CheckBox1.Checked;
end;

procedure TForm1.rgSpriteOriginClick(Sender: TObject);
const
  SO_CONSTS: array [0..1] of TSpriteOrigin = (soImage, soBitmap);
begin
  Image.SpritesOrigin := SO_CONSTS[rgSpriteOrigin.ItemIndex];
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Time := Time + 1;
  Image.Sprites[0].Position := Point(
    Round(20 + 20 * Sin(Time / 5)),
    Round(20 + 20 * Cos(Time / 5)));
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  Timer1.Interval := SpinEdit1.Value;
end;

end.
