unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DocView, StdCtrls;

type
  TForm1 = class(TForm)
    DocView1: TDocView;
    Memo1: TMemo;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    chkUnregister: TCheckBox;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
    DocView1.AppExtension := 'abc';
    DocView1.AppDescription := 'ABC Sample';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
    isRegistered: Boolean;
begin

    if chkUnregister.Checked then
    begin
        isRegistered := DocView1.CheckExtension(self); //Check if the extension is registered
        if isRegistered then
        begin
            DocView1.ShellUnreg(self);  //Unregister the file extension
        end;
        Exit;
    end
    else
    begin
    isRegistered := DocView1.CheckExtension(self); //Check if the extension is registered
    if not isRegistered then // If it's not then register it.
        DocView1.ShellReg(self, Application.ExeName,0,1);
    end;
    SaveDialog1.DefaultExt := DocView1.AppExtension;
    SaveDialog1.Filter := DocView1.AppExtension +
     ' files (*.' + DocView1.AppExtension + ')|'+'*.'+
        DocView1.AppExtension;

    if SaveDialog1.Execute() then
    begin
        DocView1.Serialize(Memo1, SaveDialog1.FileName);
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    (* The AutoLoadFile Method uses the Unserialize method of
       the component *)
    Memo1.Lines.Clear();
    DocView1.AutoLoadFile(Memo1); (* Name of the TComponent descendant that will
                                     load the explorer double clicked file's data *)
    DocView1.AutoRun('Doc View Example',Application.ExeName, false);                                     
end;                                     

procedure TForm1.Button2Click(Sender: TObject);
var
    isRegistered: Boolean;
begin
    isRegistered := DocView1.CheckExtension(self);
    if isRegistered then
    begin
        //Re-assign the extension to your application;
        With DocView1 do
        begin
            ShellReg(self,Application.ExeName,0,1);
        end;
    end;
end;

end.
